
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputErrLexer.g.
 * /!\ Don't edit it!
 */

#include "LGCOutputErrLexer.hpp"

#include <QRegularExpression>

#include <Qsci/qsciscintilla.h>

void LGCOutputErrLexer::checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK, Styles styleError)
{
	static const QString statusstring = tr(R"""(<h1 style="color: %1;">%2</h1>
		<p style="color: %1;">Value %3 is %4.</p>)""");

	if (!_lexerMode)
		return;

	bool ok = false;
	const double value = sym(symidx).toDouble(&ok);
	if (ok && (min > max || (value >= min && value <= max)))
	{
		addStyleSym(styleOK, symidx);
		return;
	}

	addStyleSym(styleError, symidx);
	if (min == max)
		_infoAnnotation += statusstring.arg("blue").arg("Info").arg(sym(symidx).toString()).arg(tr("not %1").arg(QString::number(min)));
	else
		_errorAnnotation += statusstring.arg("red").arg("Error").arg(sym(symidx).toString()).arg(tr("out of range [%2; %3]").arg(QString::number(min), QString::number(max)));
	// add marker if none with higher priority was set before
	const int pos = sym(symidx).position();
	int line, index;
	editor()->lineIndexFromPosition(pos, &line, &index);
	const std::bitset<32> markers = editor()->markersAtLine(line);
	if (marker == TextMarker::ERROR
		|| (marker == TextMarker::WARNING && !markers[TextMarker::ERROR])
		|| (!markers[TextMarker::ERROR] && !markers[TextMarker::WARNING]))
		addMarker(editor(), pos, marker);
}

void LGCOutputErrLexer::consumeRule(int rule)
{
	switch(rule)
	{
 case 6: 
	case 7:
		addStyleSym(Styles::TablePoint, 1);
		setPoint(sym(1));
		break;

	case 8:
		addStyleSym(Styles::FrameName, 1);
		setFrame(sym(1));
		break;

	case 9:
		addStyleSym(Styles::Frame, 1);
		break;
 case 31:  case 32: 
	case 33:
		addStyle(_currentLine.length(), Styles::TableFrameTransformation);
		break;
 case 34:  case 35: 
	case 36:
		addStyleSym(Styles::ValueError, 1);
		break;

	case 37:
		addStyleSym(Styles::ValueCorrect, 1);
		break;

	case 38:
		addStyleSym(Styles::ValueError, 1);
		break;

	case 40:
		endFolding();
		break;

	case 43: // HeaderStartToken
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;

	case 44:
		addStyleSym(Styles::Comment, 1);
		break;
 case 45:  case 46: 
	case 47:
		addStyleSym(Styles::Normal, 1);
		break;

	case 48:
		addStyleSym(Styles::Comment, 2);
		break;
 case 49:  case 50: 
	case 51:
		addStyleSym(Styles::Normal, 2);
		break;

	case 52:
		addStyleSym(Styles::Normal, 1);
		break;

	case 53:
		addStyleSym(Styles::Normal, 2);
		break;

	case 56:
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;

	case 57:
	{
		const double sigmamin = sym(6).mid(1).toDouble(); // All after (
		const double sigmamax = sym(8).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::ValueImportant, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::ValueImportant, 8);
		break;
	}

	case 58:
	{
		const double sigmamin = sym(7).toDouble();
		const double sigmamax = sym(9).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		break;
	}

	case 60:
		addStyleSym(Styles::Normal, 1);
		break;

	case 61:
		addStyle(_currentLine.length(), Styles::Normal);
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::ValueImportant, 11);
		break;

	case 62:
		endFolding();
		break;

	case 63:
		addStyleSym(Styles::Normal, 1);
		break;

	case 64:
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::Normal, 2);
		break;

	case 68:
		addStyleSym(Styles::ValueImportant, 1);
		addStyleSym(Styles::ValueImportant, 2);
		break;

	case 72:
		addStyle(_currentLine.length(), Styles::TableHeader);
		break;

	case 83:
		addStyle(_currentLine.length(), Styles::TableHeaderUnits);
		break;

	case 106:
		addStyleSym(Styles::ValueError, 1);
		checkNumberInRange(2, -sym(3).toDouble(), sym(3).toDouble(), TextMarker::ERROR, Styles::ValueError, Styles::ValueError);
		addStyleSym(Styles::ValueImportant, 3);
		break;

	case 107:
		addStyleSym(Styles::ValueError, 1);
		addStyleSym(Styles::ValueImportant, 2);
		// The code BELOW should be replaced by checkNumberInRange when ILLMEASUREMENT is fixed in LGC
		if (abs(sym(1).split('*')[2].toDouble()) < sym(2).toDouble()) 
			break;
		_errorAnnotation += tr(R"""(<h1 style="color: red;">ERROR</h1>
			<p style="color: red;">Value %1 is out of range %2.</p>)""").arg(sym(1).split('*')[2].toString(), sym(2).toString());
		addMarker(editor(), sym(1).position(), TextMarker::ERROR);
		break;

	case 111:
		addStyle(_currentLine.length(), Styles::ValueImportant);
		
		_curTmpFrameLevelNext = sym(1).count('_');
		if(!_curTmpFrameLevelNext) // skip ROOT
			break; 
		else if(_curTmpFrameLevelNext < _curTmpFrameLevel) // Move from nested to outer
		{
			for (int i = 0; i < _curTmpFrameLevel - _curTmpFrameLevelNext + 1; i++)
				endFolding();
		}
		else if(_curTmpFrameLevelNext == _curTmpFrameLevel) // Move from same to same
			endFolding();
		_curTmpFrameLevel = _curTmpFrameLevelNext;
			
		startFolding();
		break;

	case 115:
		addStyle(_currentLine.length(), Styles::TableHeader);
		break;
 case 133: 
	case 134: // Network Reliability
		addStyle(_currentLine.length(), Styles::OverallReliability);
		for (int i = 0; i < (_curTmpFrameLevel); i++)
			endFolding();
		break;

	case 135: // Network Reliability
		addStyle(_currentLine.length(), Styles::OverallReliability);
		break;

	} // of the switch
}

int LGCOutputErrLexer::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();
	if (tval.isEmpty())
		return LGCOutputErrLexer::WORD;
	// numbers
	if (numericrgx.match(tval).hasMatch())
	{
		bool ok;
		tval.toInt(&ok);
		if (ok)
			return LGCOutputErrLexer::INTEGER;
		tval.toDouble(&ok);
		if (ok)
			return LGCOutputErrLexer::DECIMAL;
	}
	// special characters
	if (tval.size() == 1)
	{
		switch (tval[0].unicode())
		{
		case ':':
			return LGCOutputErrLexer::COLON;
		case '=':
			return LGCOutputErrLexer::EQUAL;
		case '!':
			return LGCOutputErrLexer::EXCLAMATION;
		case '*':
			return LGCOutputErrLexer::ASTERISK;
		}
	}
	else if (tval.size() > 2 && std::all_of (std::cbegin(tval), std::cend(tval), [](const auto &ch) -> bool { return ch == '*'; }))
		return LGCOutputErrLexer::ASTERISK;
	// keywords - beginning of a line
	if (value.position() == _currentLine.position())
	{
		for (int i = 0; i < LGCOutputErrLexer::TERMINAL_COUNT; i++)
		{
			QString tmptok = LGCOutputErrLexer::spell[i];
			// If equal or has spaces and text starts with it
			if (tmptok == tval || (tmptok.contains(' ') && _currentLine.trimmed().startsWith(tmptok)))
				return i;
		}
	}
	// Ill formatted measurement where there is no space between asterisks and minus signal
	if (tval.startsWith(LGCOutputErrLexer::spell[LGCOutputErrLexer::ILLMEASUREMENT]))
		return LGCOutputErrLexer::ILLMEASUREMENT;
	// Error and Undefined keywords - can be anywhere
	for (int i = LGCOutputErrLexer::INDETERMINE; i <= LGCOutputErrLexer::ERR_ASTERISKS; i++)
	{
		if (tval == LGCOutputErrLexer::spell[i])
			return i;
	}	
	
	return LGCOutputErrLexer::WORD;
}
